Attribute VB_Name = "Registrator"
Private Type IDMPlugIn_vtbl_emulator
    pfQueryInterface        As Long
    pfAddRef                As Long
    pfRelease               As Long
    
    pfIdentifier_propget    As Long
    pfPluginName_propget    As Long
    pfVersion_propget       As Long
    pfDescription_propget   As Long
    pfEmail_propget         As Long
    pfHomePage_propget      As Long
    pfCopyright_propget     As Long
    pfMinHostVers_propget   As Long
    pfHostApp_propput       As Long
    pfConfigure_method      As Long
    pfBeforeUnload_method   As Long
    pfEventRaised_method    As Long
End Type


Private Type IDMPlugIn_interface_emulator
    ptrVTable               As Long
    nRefCounter             As Long
    RealInterface           As IDMPlugIn
End Type

Private m_FakeVTable    As IDMPlugIn_vtbl_emulator
Private m_FakeIface     As IDMPlugIn_interface_emulator

Private Function L_(ByVal l As Long) As Long: L_ = l: End Function




Public Sub RegisterPlugIn(ByRef ret As Long)
    With m_FakeIface
        .nRefCounter = 1
        .ptrVTable = VarPtr(m_FakeVTable)
        Set .RealInterface = New CTestPlugin
    End With
    
    ret = VarPtr(m_FakeIface)
End Sub


Public Sub FillFakeVtbl() '   DllEntryPoint!
    With m_FakeVTable
        .pfQueryInterface = L_(AddressOf fake_QueryInterface)
        .pfAddRef = L_(AddressOf fake_AddRef)
        .pfRelease = L_(AddressOf fake_Release)
        
        .pfIdentifier_propget = L_(AddressOf wrapper_Identifier)
        .pfPluginName_propget = L_(AddressOf wrapper_PluginName)
        .pfVersion_propget = L_(AddressOf wrapper_Version)
        .pfDescription_propget = L_(AddressOf wrapper_Description)
        .pfEmail_propget = L_(AddressOf wrapper_Email)
        .pfHomePage_propget = L_(AddressOf wrapper_Homepage)
        .pfCopyright_propget = L_(AddressOf wrapper_Copyright)
        .pfMinHostVers_propget = L_(AddressOf wrapper_MinHostVers)
        .pfHostApp_propput = L_(AddressOf wrapper_SetHostApp)
        .pfConfigure_method = L_(AddressOf wrapper_Configure)
        .pfBeforeUnload_method = L_(AddressOf wrapper_BeforeUnloadNotify)
        .pfEventRaised_method = L_(AddressOf wrapper_EventRaised)
    End With
End Sub


Private Function fake_QueryInterface(ByRef this As IDMPlugIn_interface_emulator, ByVal riid As Long, ByRef pRequiredIface As Long) As Long
    this.nRefCounter = this.nRefCounter + 1
    pRequiredIface = VarPtr(this)
End Function

Private Function fake_AddRef(ByRef this As IDMPlugIn_interface_emulator) As Long
    this.nRefCounter = this.nRefCounter + 1
    fake_AddRef = this.nRefCounter
End Function

Private Function fake_Release(ByRef this As IDMPlugIn_interface_emulator) As Long
    this.nRefCounter = this.nRefCounter - 1
    fake_Release = this.nRefCounter
    
    If this.nRefCounter = 0 Then
        Set this.RealInterface = Nothing
    End If
End Function












Private Function wrapper_Identifier(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.Identifier
    wrapper_Identifier = Err.Number
End Function

Private Function wrapper_PluginName(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.PluginName
    wrapper_PluginName = Err.Number
End Function

Private Function wrapper_Version(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.Version
    wrapper_Version = Err.Number
End Function

Private Function wrapper_Description(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator, ByVal sLang As String) As Long
    On Error Resume Next
    retval = this.RealInterface.Description(sLang)
    wrapper_Description = Err.Number
End Function

Private Function wrapper_Email(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.Email
    wrapper_Email = Err.Number
End Function

Private Function wrapper_Homepage(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.HomePage
    wrapper_Homepage = Err.Number
End Function

Private Function wrapper_Copyright(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.Copyright
    wrapper_Copyright = Err.Number
End Function

Private Function wrapper_MinHostVers(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    retval = this.RealInterface.MinHostVers
    wrapper_MinHostVers = Err.Number
End Function

Private Function wrapper_SetHostApp(ByRef this As IDMPlugIn_interface_emulator, ByVal host_app As IDMInterface) As Long
    On Error Resume Next
    Set this.RealInterface.HostApp = host_app
    wrapper_SetHostApp = Err.Number
End Function

Private Function wrapper_Configure(ByRef this As IDMPlugIn_interface_emulator, ByVal sParams As String) As Long
    On Error Resume Next
    this.RealInterface.Configure sParams
    wrapper_Configure = Err.Number
End Function

Private Function wrapper_BeforeUnloadNotify(ByRef this As IDMPlugIn_interface_emulator) As Long
    On Error Resume Next
    this.RealInterface.BeforeUnloadNotify
    wrapper_BeforeUnloadNotify = Err.Number
End Function

Private Function wrapper_EventRaised(ByRef retval As String, ByRef this As IDMPlugIn_interface_emulator, ByVal sEventType As String, ByVal sEventData As String) As Long
    On Error Resume Next
    retval = this.RealInterface.EventRaised(sEventType, sEventData)
    wrapper_EventRaised = Err.Number
End Function






